import React from 'react'
import { translate } from 'cozy-ui/react/I18n'
import StyledOauthButton from 'components/CommonKit/Button/StyledOauthButton'
import StyledIcon from 'components/CommonKit/Icon/StyledIcon'
import iconEnedisLogo from 'assets/icons/visu/enedis-logo.svg'
import Config from '../../../../config.json'

interface ActivateHalfHourLoadProps {
  t: Function // translation service
}
const ActivateHalfHourLoad = ({ t }: ActivateHalfHourLoadProps) => {
  const siteLink = Config.fluidConfig[0].siteLink //TODO change here

  return (
    <div className="cta-box">
      <div className="cta-box-header header-text text-16-normal">
        {t('timestep.activate.enedis.info')}
      </div>
      <StyledOauthButton
        className="cta-box-button"
        type="button"
        color="primary"
        onClick={() => window.open(siteLink, '_blank')}
      >
        <div className="oauthform-button-content">
          <div className="oauthform-button-content-icon">
            <StyledIcon icon={iconEnedisLogo} size={48} />
          </div>
          <div className="oauthform-button-text text-18-bold">
            <div> {t('timestep.activate.enedis.label1')}</div>
          </div>
        </div>
      </StyledOauthButton>
    </div>
  )
}

export default translate()(ActivateHalfHourLoad)
